
/*
 * Test various lookups, including errant ones.
 */
	
/*
 * This file is part of the Cleansocks library.  It is released under the
 * Lesser GNU GPL.  See the accompanying files COPYING and COPYING.LESSER.
 */

#include <iostream>
#include <string>
#include <stdexcept>
#include <cleanip.h>

using namespace std;
using namespace cleansocks;

int main(int argc, char **argv)
{
	// Hack alert!  Switch default case sets i so that the loop will exit.
	// This way, I can add tests and not worry about forgetting to update the
	// loop limit as well.
	for(int i = 1; i > 0; ++i) {
		IPaddress a;
		IPport p;

		cout << "*** Test " << i << " ***" << endl;

		try {
			switch(i)
			{
			case 1:
				a = lookup_host("www.google.com");
				cout << "www.google.com: " << a << endl;
				break;
			case 2:
				a = lookup_host("xyz.bogus.edu");
				cout << "xyz.bogus.edu: " << a << endl;
				break;
			case 3:	
				p = lookup_service("gonzobibble");
				cout << ":gonzobibble " << p << endl;
				break;
			case 4:	
				a = lookup_host("sandbox.mc.edu");
				cout << "sandbox.mc.edu: " << a << endl;
				break;
			case 5:	
				p = lookup_service("http");
				cout << "http: " << p << endl;
				break;
			case 6:	
				p = lookup_service("smtp");
				cout << "smtp: " << p << endl;
				break;
			case 7:	
				a = lookup_host("ftp");
				cout << "ftp (as host): " << a << endl;
				break;
			case 8:	
				a = lookup_host("localhost");
				cout << "localhost: " << a << endl;
				break;
			default:
				cout << "Testing done" << endl;
				i = -1;
			}
		}
		catch(socket_db_error e) {
			cout << "Socket db error: " << e.what() << endl;
		}
		catch(socket_error e) {
			cout << "Socket error: " << e.what() << endl;
		}
		catch(runtime_error e) {
			cout << "Runtime error: " << e.what() << endl;
		}
	}
}
