/*
 * Test printing, .str() and some other extractors of IP address, port and
 * endpoint.
 */

/*
 * This file is part of the Cleansocks library.  It is released under the
 * Lesser GNU GPL.  See the accompanying files COPYING and COPYING.LESSER.
 */

#include <iostream>
#include <string>

#include "cleansocks.h"
#include "cleanip.h"

using namespace cleansocks;


void dotest(const IPaddress &ipa, const IPport &ipp)
{
	std::cout << "========" << std::endl;

	std::cout << "[" << ipa << "] [" << ipp << "]" << std::endl;
	std::cout << "<"+ipa.str()+"> <"+ipp.str()+">" << std::endl;

	IPendpoint ipe(ipa,ipp);
	std::cout << "[" << ipe << "]" << std::endl;
	std::cout << "<"+ipe.str()+">" << std::endl;

	std::cout << "Raw IP addr values: " << ipa.get() << " " << ipa.net()
		  << std::endl;
	std::cout << "Raw port values: " << ipp.get() << " " << ipp.net()
		  << std::endl;
	
	std::cout << std::endl;
}

int main(int argc, char **argv)
{
#if defined(__i386__) || defined(__x86_64__)
	std::cout << "Generating for PC byte order." << std::endl;
#else
	std::cout << "Not PC architecture.  Verify output is correct for "
		  << "target architecture." << std::endl;
#endif	

	dotest("12.18.148.255", 7821);
	dotest("210.110.20.40", 387);
	dotest(IPaddress(12,18,148,255),IPport(30,141));

	IPaddress ipa;
	IPport ipp;
	ipa.net(htonl(0x0c1294ff));
	ipp.net(htons(7821));
	dotest(ipa,ipp);
}
